<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <title>Task 31.10</title>
    <style>
      .div-background-picture {
        /*the image used*/
        background-image: url("images/signup-bg.jpg");
        height: 100%;
        /*center and scale the image nicely*/
        background-position: center;
        background-repeat: no-repeat;
        background-size: cover;
        opacity: 0.7;
      }
    </style>
  </head>
  <body>
    <div class="container-fluid div-background-picture">
      <form id="form-login" action="#" method="post">
        <div class="row d-flex align-items-center min-vh-100">
          <div class="col-sm-4 text-center mx-auto my-0 jumbotron">
            <div class="form-group">
              <h2 class="text-center">Creat Account</h2>
            </div>
            <div class="form-group">
              <div class="row">
                <div class="col">
                  <input
                    type="text"
                    class="form-control"
                    id="inp-your-name"
                    placeholder="Your Name"
                  />
                </div>
              </div>
            </div>
            <div class="form-group">
              <input
                type="email"
                class="form-control"
                id="inp-email"
                placeholder="Your Email"
              />
            </div>
            <div class="form-group">
              <input
                type="password"
                class="form-control"
                id="inp-password"
                placeholder="Password"
              />
            </div>
            <div class="form-group">
              <input
                type="password"
                class="form-control"
                id="inp-repeat-password"
                placeholder="Repeat your Password"
              />
            </div>
            <div class="form-group">
              <input type="checkbox" id="check-confirm-accept" />I agree all
              statements in <a href="#">Terms of service</a>
              <p id="p-agree-feedback" class="invalid-feedback">
                You must accept before submitting
              </p>
            </div>
            <div class="form-group">
              <button id="btn-sign-up" class="btn btn-success btn-lg col-sm-12">
                Sign Up
              </button>
            </div>
            <div class="form-group text-center">
              Have already an account? <a href="#"><b>Login here</b></a>
            </div>
          </div>
        </div>
      </form>
    </div>
    <script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      var gEleYourName = $("#inp-your-name");
      var gEleEmail = $("#inp-email");
      var gElePassword = $("#inp-password");
      var gEleRepeatPass = $("#inp-repeat-password");
      var gEleAcceptCheck = $("#check-confirm-accept");

      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
      $(document).ready(function () {
        $("#btn-sign-up").on("click", function (event) {
          event.preventDefault();
          onBtnSignUpClick();
        });
      });

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      //hàm xử lý khi bấm nút sign up
      function onBtnSignUpClick() {
        ("use strict");
        //khai báo object
        var vUserObj = {
          yourname: "",
          email: "",
          password: "",
          repeatpassword: "",
          iAccept: false,
        };

        //b1: đọc
        getFormInputData(vUserObj);

        //b2: kiểm tra
        var vIsValid = validateForm(vUserObj);
        //b3: xử lý hiển thị
        if (vIsValid) {
          showDataInConsole(vUserObj);
        }
      }

      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      //hàm đọc dữ liệu
      function getFormInputData(paramUserDataObj) {
        paramUserDataObj.yourname = gEleYourName.val();
        paramUserDataObj.email = gEleEmail.val();
        paramUserDataObj.password = gElePassword.val();
        paramUserDataObj.repeatpassword = gEleRepeatPass.val();
        paramUserDataObj.iAccept = gEleAcceptCheck.is(":checked");
      }

      //hàm kiểm tra dữ liệu
      function validateForm(paramUserDataObj) {
        if (paramUserDataObj.yourname == "") {
          alert("chưa nhập your name ...!");
          return false;
        }
        var vCheckEmail = validateEmail(paramUserDataObj.email);
        if (vCheckEmail && paramUserDataObj.password == "") {
          alert("chưa nhập password!");
          return false;
        }
        if (vCheckEmail && paramUserDataObj.password.length < 8) {
          alert("password phải chứa ít nhất 8 kí tự!");
          return false;
        }
        if (
          vCheckEmail &&
          paramUserDataObj.password != paramUserDataObj.repeatpassword
        ) {
          alert("Confirm password không khớp. Kiểm tra lại!");
          return false;
        }
        if (vCheckEmail && !paramUserDataObj.iAccept) {
          $("#p-agree-feedback").css("display", "block");
          alert("You must accept before submitting");
          return false;
        } else {
          $("#p-agree-feedback").css("display", "none");
        }
        return true;
      }

      //kiêm tra email
      function validateEmail(paramEmail) {
        var vRegexStr = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
        if (paramEmail == "") {
          alert("chưa nhập email ...!");
          return false;
        }
        if (!vRegexStr.test(paramEmail)) {
          alert("email đã nhập không hợp lệ ...!");
          return false;
        }
        return true;
      }

      //hàm ghi thông tin ra console
      function showDataInConsole(paramUserDataObj) {
        console.log("yourname: " + paramUserDataObj.yourname);
        console.log("email: " + paramUserDataObj.email);
        console.log("password: " + paramUserDataObj.password);
        console.log("repeatpassword: " + paramUserDataObj.repeatpassword);
        console.log("I accept: " + paramUserDataObj.iAccept);
      }
    </script>
  </body>
</html>
